unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    cbSelect: TRadioButton;
    cbBubbleSimple: TRadioButton;
    cbBubbleClassic: TRadioButton;
    cbShake: TRadioButton;
    Label2: TLabel;
    Timer1: TTimer;
    Label3: TLabel;
    lbTime: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

var Start, Stop:TDateTime;

procedure TForm2.Button1Click(Sender: TObject);
 var I, J, N, Pom, ZM, PZM, D, H:Integer;
     A:array of Integer;
begin
 Memo1.Clear;
 lbTime.Caption:='***';
 N:=Memo2.Lines.Count;
 Setlength(A, N);
 for I:=0 to N-1 do
 A[I+1]:=StrToInt(Memo2.Lines[I]);

 Start:=Now;

 if cbSelect.Checked then
 begin
  for I:=1 to N-1 do    //Outer loop - if minimum is found in inner loop, unsorted sequence is shortened by 1
  begin
   for J:=I+1 to N  do   //Inner loop - conducts one pass through the queue
   begin
    if A[J] < A[I]     //Each element in unsorted sequence is compared with the first one
    then begin
     POM:= A[I];
     A[I]:= A[J];
     A[J]:= POM;
    end;
   end;
  end;
 end;

 if cbBubbleSimple.Checked then
 begin
  for I:=N downto 2 do   //Outer loop - control variable is decreasing
  begin
   for J:=1 to I-1  do   //Inner loop - conducts one pass through the queue
   begin
    if A[J] > A[J+1]
    then
    begin
     POM:= A[J];
     A[J]:= A[J+1];
     A[J+1]:= POM;
    end;
   end;
  end;
 end;

 if cbBubbleClassic.Checked then
 begin
  for I:=N downto 2 do    //Outer loop - control variable is decreasing
  begin
   ZM:=0;
   for J:=1 to I-1  do   //Inner loop / conducts one pass through the queue
   begin
    if A[J] > A[J+1]
    then
    begin
     POM:= A[J];
     A[J]:= A[J+1];
     A[J+1]:= POM;
     ZM:=1;       //Change is encountered
    end;
   end;
   if ZM=0 then break;  //If no change, breaks the loop
   ZM:=0;               //Elements order has changed, must be passed again
  end;
 end;

 if cbShake.Checked then
 begin
  D:=1;                               //Lower limit is at the beginning of the queue
  H:=N-1;      //Upper limit must allow a comparison with an element one position higher
  PZM:=1;
  repeat       //Outer loop with a condition at the end
   for J:= D to H do                //Loop 1 - from bottom to top
   begin
    if A[J] > A[J+1]
    then
    begin
     POM:= A[J]; A[J]:= A[J+1]; A[J+1]:= POM;
     PZM:=J            //Last change is saved
    end;
   end;
   H:=PZM-1;  //Shifts upper limit from which searching is started
   for J:= H downto D do            //Loop 2 - from top to bottom
   begin
    if A[J+1] < A[J]
    then
    begin
     POM:= A[J]; A[J]:= A[J+1]; A[J+1]:= POM;
     PZM:=J            //Last change
    end;
   end;
   D:=PZM+1;  //Shifts lower limit from which searching is started
  until D>H;   //Are limits equal? End of outer loop
 end;

 Stop:=Now;

 for I:=0 to N-1 do Memo1.Lines.Add(IntToStr(A[I+1]));

 lbTime.Caption:=FormatDateTime('hh.nn.ss.zzz', Stop-Start);
end;

end.
